Index: code/branches/console/src/audio/AudioStream.cc
===================================================================
--- code/branches/console/src/audio/AudioStream.cc	(revision 1437)
+++ code/branches/console/src/audio/AudioStream.cc	(revision 1438)
@@ -117,5 +117,7 @@
 
 	    for(int i = 0; i < vorbisComment->comments; i++)
+	    {
 	        COUT(3) << "   " << vorbisComment->user_comments[i] << std::endl;
+	    }
 
 	    COUT(3) << std::endl;
Index: code/branches/console/src/core/Script.cc
===================================================================
--- code/branches/console/src/core/Script.cc	(revision 1437)
+++ code/branches/console/src/core/Script.cc	(revision 1438)
@@ -128,5 +128,8 @@
     if (error == 0)
       error = lua_pcall(luaState_, 0, 0, 0);
-    if (error != 0) COUT(2) << "Error in Lua-script: " << lua_tostring(luaState_, -1) << std::endl;
+    if (error != 0)
+    {
+      COUT(2) << "Error in Lua-script: " << lua_tostring(luaState_, -1) << std::endl;
+    }
   }
 
Index: code/branches/console/src/core/TclBind.cc
===================================================================
--- code/branches/console/src/core/TclBind.cc	(revision 1437)
+++ code/branches/console/src/core/TclBind.cc	(revision 1438)
@@ -110,5 +110,7 @@
 
         if (!CommandExecutor::execute(command, false))
+        {
             COUT(1) << "Error: Can't execute command \"" << command << "\"!" << std::endl;
+        }
 
         if (CommandExecutor::getLastEvaluation().hasReturnvalue())
@@ -124,5 +126,7 @@
 
         if (!CommandExecutor::execute(command, false))
+        {
             COUT(1) << "Error: Can't execute command \"" << command << "\"!" << std::endl;
+        }
     }
 
@@ -133,5 +137,7 @@
             std::string output = TclBind::getInstance().interpreter_->eval(tclcode);
             if (output != "")
+            {
                 COUT(0) << "tcl> " << output << std::endl;
+            }
             return output;
         }
Index: code/branches/console/src/network/GameStateClient.cc
===================================================================
--- code/branches/console/src/network/GameStateClient.cc	(revision 1437)
+++ code/branches/console/src/network/GameStateClient.cc	(revision 1438)
@@ -102,5 +102,7 @@
           // update data and create object/entity...
           if( !no->updateData(sync) && !no->create() )
+          {
             COUT(1) << "We couldn't create/update the object: " << sync.objectID << std::endl;
+          }
           ++it;
         }
@@ -108,6 +110,8 @@
         // we have our object
         if(! it->updateData(sync))
+        {
           COUT(1) << "We couldn't update objectID: " \
           << sync.objectID << "; classID: " << sync.classID << std::endl;
+        }
       }
       ++it;
Index: code/branches/console/src/network/PacketDecoder.cc
===================================================================
--- code/branches/console/src/network/PacketDecoder.cc	(revision 1437)
+++ code/branches/console/src/network/PacketDecoder.cc	(revision 1438)
@@ -176,8 +176,12 @@
     //since data is not allocated, because it's just a pointer, allocate it with size of gamestatedatastream
     if(currentState->compsize==0)
+    {
       COUT(2) << "compsize is 0" << std::endl;
+    }
     currentState->data = (unsigned char*)(malloc( currentState->compsize ));
     if(currentState->data==NULL)
+    {
       COUT(2) << "Gamestatepacket-decoder: memory leak" << std::endl;
+    }
     //copy the GameStateCompressed data
     //std::cout << "packet size (enet): " << packet->dataLength << std::endl;
@@ -252,5 +256,7 @@
   {
     if(clientId!=CLIENTID_CLIENT)
+    {
       COUT(5) << "client: " << clientId << std::endl;
+    }
     COUT(5) << "data id: " << data->id << std::endl;
     COUT(5) << "data:    " << data->message << std::endl;
Index: code/branches/console/src/network/dummyclient3.cc
===================================================================
--- code/branches/console/src/network/dummyclient3.cc	(revision 1437)
+++ code/branches/console/src/network/dummyclient3.cc	(revision 1438)
@@ -51,6 +51,11 @@
   Client client( str, PORT );
   if ( client.establishConnection() )
+  {
     COUT(3) << "connection established" << std::endl;
-  else COUT(0) << "problems establishing connection" << std::endl;
+  }
+  else
+  {
+    COUT(0) << "problems establishing connection" << std::endl;
+  }
   char message[10000];
   char signs[] = "abcdefghijklmnopqrstuvwxy";