Index: /code/branches/network/CMakeLists.txt
===================================================================
--- /code/branches/network/CMakeLists.txt	(revision 1444)
+++ /code/branches/network/CMakeLists.txt	(revision 1445)
@@ -74,4 +74,5 @@
 FIND_PACKAGE(Lua)
 FIND_PACKAGE(TCL)
+FIND_PACKAGE(DirectX)
 
 #Set the search paths for the linking
@@ -99,4 +100,6 @@
   ${Lua_INCLUDE_DIR}
   ${TCL_INCLUDE_PATH}
+  ${DirectX_INCLUDE_DIR}
+  ${ZLIB_INCLUDE_DIR}
 )
 
Index: /code/branches/network/cmake/FindDirectX.cmake
===================================================================
--- /code/branches/network/cmake/FindDirectX.cmake	(revision 1445)
+++ /code/branches/network/cmake/FindDirectX.cmake	(revision 1445)
@@ -0,0 +1,34 @@
+IF(WIN32)
+  # - Test for DirectX
+  # Once loaded this will define
+  #   DirectX_FOUND        - system has DirectX
+  #   DirectX_INCLUDE_DIR  - include directory for DirectX
+  #   DirectX_LIB_DIR      - lib directory for DirectX
+
+  set(DirectX_FOUND "NO")
+
+  FIND_PATH(DirectX_INCLUDE_DIR "dinput.h"
+    C:/DXSDK/Include
+  )
+
+  FIND_PATH(DirectX_LIB_DIR "dinput8.lib"
+    C:/DXSDK/Lib
+    C:/DXSDK/Lib/x86
+  )
+
+  if(DirectX_INCLUDE_DIR AND DirectX_LIB_DIR)
+    set(DirectX_FOUND "YES")
+  endif(DirectX_INCLUDE_DIR AND DirectX_LIB_DIR)
+
+  if (DirectX_FOUND)
+    if (NOT DirectX_FIND_QUIETLY)
+      message(STATUS "Found DirectX")
+    endif (NOT DirectX_FIND_QUIETLY)
+  else (DirectX_FOUND)
+    if (DirectX_FIND_REQUIRED)
+      message(FATAL_ERROR "Could not find DirectX")
+    else (DirectX_FOUNC)
+      message(STATUS "Could not find DirectX")
+    endif (DirectX_FIND_REQUIRED)
+  endif (DirectX_FOUND)
+ENDIF(WIN32)
Index: /code/branches/network/cmake/FindZLIB.cmake
===================================================================
--- /code/branches/network/cmake/FindZLIB.cmake	(revision 1444)
+++ /code/branches/network/cmake/FindZLIB.cmake	(revision 1445)
@@ -58,4 +58,8 @@
   ENDIF(EXISTS "../libs/ogre/Dependencies/lib/Release")
 
+  FIND_PATH(ZLIB_INCLUDE_DIR zlib.h
+    ../libs/ogre/Dependencies/include
+  )
+
   FIND_LIBRARY(ZLIB_LIBRARY
     NAMES zlib
@@ -63,8 +67,8 @@
   )
 
-  IF(ZLIB_LIBRARY)
+  IF(ZLIB_LIBRARY AND ZLIB_INCLUDE_DIR)
     MESSAGE(STATUS "Zlib was found.")
-  ELSE(ZLIB_LIBRARY)
+  ELSE(ZLIB_LIBRARY AND ZLIB_INCLUDE_DIR)
     MESSAGE(FATAL_ERROR "Zlib was NOT found.")
-  ENDIF(ZLIB_LIBRARY)
+  ENDIF(ZLIB_LIBRARY AND ZLIB_INCLUDE_DIR)
 ENDIF(WIN32)
Index: /code/branches/network/src/core/XMLPort.h
===================================================================
--- /code/branches/network/src/core/XMLPort.h	(revision 1444)
+++ /code/branches/network/src/core/XMLPort.h	(revision 1445)
@@ -166,5 +166,5 @@
                         }
                     }
-                    catch(ticpp::Exception& ex)
+                    catch (ticpp::Exception& ex)
                     {
                         COUT(1) << std::endl;
@@ -344,5 +344,5 @@
                         }
                     }
-                    catch(ticpp::Exception& ex)
+                    catch (ticpp::Exception& ex)
                     {
                         COUT(1) << std::endl;
Index: /code/branches/network/src/ois/CMakeLists.txt
===================================================================
--- /code/branches/network/src/ois/CMakeLists.txt	(revision 1444)
+++ /code/branches/network/src/ois/CMakeLists.txt	(revision 1445)
@@ -37,2 +37,11 @@
 
 ADD_LIBRARY( ois SHARED ${OIS_SRC_FILES} )
+
+IF(WIN32)
+  LINK_DIRECTORIES(${DirectX_LIB_DIR})
+  TARGET_LINK_LIBRARIES( ois
+    dxguid
+    dinput8
+  )
+ENDIF(WIN32)
+
Index: /code/branches/network/src/ois/OISException.cpp
===================================================================
--- /code/branches/network/src/ois/OISException.cpp	(revision 1444)
+++ /code/branches/network/src/ois/OISException.cpp	(revision 1445)
@@ -26,7 +26,7 @@
 
 //----------------------------------------------------------------------------//
-const char* Exception::what() const throw()
+/*const char* Exception::what() const throw()
 {
 	return eText;
 }
-
+*/
Index: /code/branches/network/src/ois/OISException.h
===================================================================
--- /code/branches/network/src/ois/OISException.h	(revision 1444)
+++ /code/branches/network/src/ois/OISException.h	(revision 1445)
@@ -58,7 +58,6 @@
 			: eType(err), eLine(line), eFile(file), eText(str) {}
 
-		~Exception() throw() {}
-
-		virtual const char* what() const throw();
+		virtual const char* what() const throw()
+            { return eText; }
 
 		//! The type of exception raised